package org.eclipse.persistence.jpa.inheritance.model;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.PrePersist;
import javax.persistence.Transient;
import javax.persistence.Version;

@Entity
@Inheritance(strategy = InheritanceType.TABLE_PER_CLASS)
public class ParentEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    long id;

    @Version
    int version;

    @Transient
    int prePersistParent = 0;

    public ParentEntity() {

    }

    @PrePersist
    public void beforeParent() {
        prePersistParent++;
    }

    public int getPrePersistParent() {
        return prePersistParent;
    }
}
