package org.eclipse.persistence.jpa.inheritance.test;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.eclipse.persistence.jpa.inheritance.model.ChildEntity;
import org.eclipse.persistence.jpa.inheritance.model.ParentEntity;
import org.eclipse.persistence.jpa.test.framework.DDLGen;
import org.eclipse.persistence.jpa.test.framework.Emf;
import org.eclipse.persistence.jpa.test.framework.EmfRunner;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;

@RunWith(EmfRunner.class)
public class TestInheritancePrePersist {
    @Emf(classes = { ChildEntity.class, ParentEntity.class })
    EntityManagerFactory emf;

    @Test
    public void testMultiplePrePersist() {
        EntityManager em = emf.createEntityManager();
        try {
            em.getTransaction().begin();
            ChildEntity ce = new ChildEntity();
            em.persist(ce);

            em.getTransaction().commit();

            em.clear();
            // Assert.assertEquals(1, ce.getPrePersistChild());
            Assert.assertEquals(1, ce.getPrePersistParent());
        } finally {
            if (em.getTransaction().isActive()) {
                em.getTransaction().rollback();
            }
            em.close();
        }
    }

    @Test
    public void t2() {

    }

    @Test
    public void t3() {

    }
}
