package org.eclipse.persistence.jpa.test.framework;

import org.junit.runner.notification.RunNotifier;
import org.junit.runners.BlockJUnit4ClassRunner;
import org.junit.runners.model.InitializationError;

public class EmfRunner extends BlockJUnit4ClassRunner {
    private final EmfManager _mgr;
    
    public EmfRunner(Class<?> cls) throws InitializationError {
        super(cls);
        _mgr = new EmfManager();
    }

    @Override
    protected Object createTest() throws Exception {
        Object testInstance = super.createTest();
        
        _mgr.inject(testInstance);

        return testInstance;
    }

    @Override
    public void run(RunNotifier notifier) {
        super.run(notifier);
        _mgr.close();
    }
}
